	include "p16c84.inc"

	__FUSES _CP_OFF & _XT_OSC & _PWRTE_ON & _WDT_OFF


	title "Variables *****************************************"
_NINV	equ 0x0c
_INV	equ 0x0d
_BLACK	equ 0x0e
_BURST	equ 0x0f
_SYNC	equ 0x10
_delay_	equ 0x11
_video	equ 0x12
param00_delay	equ 0x13
_n_main	equ 0x14
_temp   equ 0x15

	ORG 0

	movlw D'33'
	movwf _NINV
	movlw D'34'
	movwf _INV
	movlw D'20'
	movwf _BLACK
	movlw D'28'
	movwf _BURST
	movlw D'16'
	movwf _SYNC
	movlw D'0'
	movwf _delay_
	movf  _NINV, W
	movwf _video
_main
	bcf   INTCON, GIE
	bsf   STATUS, RP0
	bcf   OPTION_REG, 7
	movlw D'31'
	movwf TRISA
	movlw D'0'
	movwf TRISB
	bcf   STATUS, RP0
	movf  _video, W
	movwf PORTB
_wait_to_rise1
	btfss PORTA, 3
	goto  _wait_to_rise1
_wait_to_rise2
	btfss PORTA, 3
	goto  _wait_to_rise2
_wait_to_rise3
	btfss PORTA, 3
	goto  _wait_to_rise3
_wait_to_fall
	btfsc PORTA, 3
	goto  _wait_to_fall
_Main_Loop
        movf  _temp,w
        movwf _video


	movlw D'1'
	movwf _n_main
label_0
	movlw D'142'
	subwf _n_main, W
	movlw 1
	btfsc STATUS, C
	clrw
	sublw 0
	btfsc STATUS, Z
	goto label_1
	call _normaline
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	call _normaline
	nop
	nop
	incf _n_main, F
	goto label_0
label_1
	call _senseline
	call _vertical2
	call _vertical1
	call _vertical2
        movf  _video,w
        movwf _temp
        movf  _BLACK,w
        movwf _video

	movlw D'1'
	movwf _n_main
label_4
	movlw D'15'
	subwf _n_main, W
	movlw 1
	btfsc STATUS, C
	clrw
	sublw 0
	btfsc STATUS, Z
	goto label_5
	call _normaline
	nop
	nop
	incf _n_main, F
	goto label_4
label_5
	call _triggerline
	movlw D'75'
	movwf param00_delay
	call _delay

        movf  _temp,w
        movwf _video

	movlw D'1'
	movwf _n_main
label_6
	movlw D'142'
	subwf _n_main, W
	movlw 1
	btfsc STATUS, C
	clrw
	sublw 0
	btfsc STATUS, Z
	goto label_7
	call _normaline
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	call _normaline
	nop
	nop
	incf _n_main, F
	goto label_6
label_7
	call _senseline
	call _vertical2
	call _vertical1
	call _vertical2
        movf  _video,w
        movwf _temp
        movf  _BLACK,w
        movwf _video
	movlw D'1'
	movwf _n_main
label_10
	movlw D'15'
	subwf _n_main, W
	movlw 1
	btfsc STATUS, C
	clrw
	sublw 0
	btfsc STATUS, Z
	goto label_11
	call _normaline
	nop
	nop
	incf _n_main, F
	goto label_10
label_11
	call _triggerline
	movlw D'75'
	movwf param00_delay
	call _delay
	goto _Main_Loop
_delay
	movf param00_delay, W
	movwf _delay_
_la_1
	decfsz _delay_
	goto _la_1
	return
_vertical1
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	return
_vertical2
	movf _BLACK, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'44'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	return

_normaline
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'3'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	nop
	nop
	nop
	nop
	nop
;	movf _BURST, W
        movf _BLACK, W
	movwf PORTB
	bsf PORTB, 7
_w_r1
	btfss PORTA, 2
	goto _w_r1
_w_r2
	btfss PORTA, 2
	goto _w_r2
_wt_fall
	btfsc PORTA, 2
	goto _wt_fall
	nop
	nop
	nop
	bcf PORTB, 7
	movf _video, W
	movwf PORTB
	movlw D'77'
	movwf param00_delay
	call _delay
	return

_triggerline
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'3'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'8'
	movwf param00_delay
	call _delay
_wait_1_to_rise1
	btfss PORTA, 3
	goto _wait_1_to_rise1
_wait_1_to_rise2
	btfss PORTA, 3
	goto _wait_1_to_rise2
_wait_1_to_fall
	btfsc PORTA, 3
	goto _wait_1_to_fall
	movf _BLACK, W
	movwf PORTB
	return
_senseline
	movf _BLACK, W
	movwf PORTB
	movlw D'1'
	movwf param00_delay
	call _delay
	movf _SYNC, W
	movwf PORTB
	movlw D'3'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'8'
	movwf param00_delay
	call _delay
	movf _BLACK, W
	movwf PORTB
	movlw D'30'
	movwf param00_delay
	call _delay

	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W
	btfss	PORTA, 0
        movf    _NINV,W
        movf    _INV ,W

	movwf	_video
	movlw D'20'
	movwf param00_delay
	call _delay
	return

	END
